Subject: bug#57531: 28.1; Character encoding missing for "eo"

From: Eli Zaretskii <[email-masked]>
Date: Sat, 03 Sep 2022 17:47:59 +0300

> Date: Sat, 03 Sep 2022 01:28:56 +0000
> From: Jonathan Reeve <[email-masked]>
> Cc: [email-masked]
> 
> “Eli Zaretskii” <[email-masked]> writes:
> 
> > Can you tell what is the default encoding in that case?
> 
> It looks like it’s `iso-latin-3', which is not working, since all my unicode characters get mangled. See [the screenshot in this question of mine on StackExchange.]

The characters in that post are supported by Latin-3, and I had no
problem saving them.

> > If you want the UTF-8 encoding to be the default, why is your locale
> > set to “eo” and not to “eo.UTF-8”?
> 
> There is no eo.UTF-8 locale available to the system, as you can see [from the glibc documentation]. The “eo” locale is actually UTF-8, however. It’s interpreted as such just fine, across my whole system, except for in the emacs terminal, where it gets interpreted as `iso-latin-3'.

That's okay, but then all you need to say in Emacs is

  (prefer-coding-system 'utf-8)

Put that in your init file, and see if your problem with non-ASCII
characters is fixed.

> > Are you saying that the Esperanto locale _must_ use UTF-8?  If so,
> > why?  AFAIK, ISO-8859-3 covers the Esperanto characters, so UTF-8 is
> > not the only possible codeset for Esperanto locales.
> 
> If you look at that glibc document, you’ll see that the “eo” locale is actually UTF-8. Unlike `en_US', which has variants like  `en_US.UTF-8' which is UTF-8 and `en_US' which is ISO-8859-1, there is only `eo/UTF-8', i.e., `eo' which is UTF-8.

I don't know why glibc did that, and glibc-supported systems are not
the only ones where we want to support Esperanto.  So if the above
simple customization fixes your problem, I'd prefer not changing the
default for everyone.

Thanks.